RT_Template = {

	Create = function()
		
		local tasks = RT_Task.Active
		local template = {}
		
		if(table.getn(tasks) > 0) then
			for index, task in ipairs(tasks) do
				
				local taskTpl = template[table.getn(template)+1]
				taskTpl = {}
				taskTpl.title = RT_Task.GetTitle(task)
				taskTpl.targets = {}
				taskTpl.assisters = {}
				
				local targets = { RT_Task.GetTargetsFrame(task):GetChildren() }
				local assisters = { RT_Task.GetAssistersFrame(task):GetChildren() }
				
				for _, player in ipairs(targets) do
					table.insert(taskTpl["targets"], player.Name)
				end
				
				for _, player in ipairs(assisters) do
					table.insert(taskTpl["assisters"], player.Name)
				end
				
				table.insert(template, taskTpl)
			end
		end
		
		return template
	end,
	
	Save = function(name)
		RT_Data.Templates[name] = RT_Template.Create()
	end,
	
	Load = function(name)
		if(RT_Data.Templates[name] ~= nil) then
			RT_Task.RemoveAll()
			local template = RT_Data.Templates[name]
			local players = RT_Player.Active
			
			for _, task in ipairs(template) do
				taskFrame = RT_Task.Create(task.title)
				
				local targetsFrame = RT_Task.GetTargetsFrame(taskFrame)
				for _, target in ipairs(task.targets) do 
					if(players[target] ~= nil) then
						players[target]:SetParent(targetsFrame)
					end
				end
				
				local assistersFrame = RT_Task.GetAssistersFrame(taskFrame)
				for _, assister in ipairs(task.assisters) do
					if(players[assister] ~= nil) then
						players[assister]:SetParent(assistersFrame)
					end
				end
				
			end
			
			RT_Main.PositionTasks()
			RT_Main.ForceRender()
		end
	end,
	
	Delete = function(name)
		RT_Data.Templates[name] = nil
	end,
	
	CSList = function()
		local list = ""
		local names = {}
		
		for name in pairs(RT_Data.Templates) do table.insert(names, name) end
		if(table.getn(names) > 0) then list = table.concat(names, ', ') end
		return list
	end,
	
}